#ifndef FD_Paint_h_
#define FD_Paint_h_
/* Header file generated with fdesign. */

/**** Callback routines ****/

extern void callback_fileMenu(FL_OBJECT *, long);
extern void callback_cameraMenu(FL_OBJECT *, long);
extern void callback_renderMenu(FL_OBJECT *, long);
extern void callback_optionsMenu(FL_OBJECT *, long);
extern void callback_refresh(FL_OBJECT *, long);
extern void callback_aboutMenu(FL_OBJECT *, long);

extern void callback_form7_OK(FL_OBJECT *, long);
extern void Set_Camera_Cancel(FL_OBJECT *, long);
extern void callback_form7_UPDATE(FL_OBJECT *, long);
extern void callback_perspective(FL_OBJECT *, long);
extern void callback_parallel(FL_OBJECT *, long);

extern void callback_form8_OK(FL_OBJECT *, long);
extern void Set_View_Cancel(FL_OBJECT *, long);
extern void callback_form8_UPDATE(FL_OBJECT *, long);

extern void callback_form3_OK(FL_OBJECT *, long);
extern void Set_Display_Cancel(FL_OBJECT *, long);
extern void callback_form3_UPDATE(FL_OBJECT *, long);

extern void callback_form4_OK(FL_OBJECT *, long);
extern void Set_Color_Cancel(FL_OBJECT *, long);
extern void callback_form4_UPDATE(FL_OBJECT *, long);
extern void callback_rgb_color(FL_OBJECT *, long);
extern void callback_grayscale(FL_OBJECT *, long);
extern void callback_pseudocolor(FL_OBJECT *, long);

extern void callback_form5_OK(FL_OBJECT *, long);
extern void Set_Convergence_Cancel(FL_OBJECT *, long);

extern void callback_form2_OK(FL_OBJECT *, long);
extern void Entities_Cancel(FL_OBJECT *, long);

extern void callback_form6_OK(FL_OBJECT *, long);

extern void callback_form9_OK(FL_OBJECT *, long);

extern void callback_form10_OK(FL_OBJECT *, long);

extern void callback_form11_OK(FL_OBJECT *, long);

extern void callback_form12_OK(FL_OBJECT *, long);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *Paint;
	void *vdata;
	long ldata;
	FL_OBJECT *file_menu;
	FL_OBJECT *camera_menu;
	FL_OBJECT *render_menu;
	FL_OBJECT *options_menu;
	FL_OBJECT *pane;
	FL_OBJECT *exit;
	FL_OBJECT *Exit;
	FL_OBJECT *refresh;
	FL_OBJECT *about_menu;
} FD_Paint;

extern FD_Paint * create_form_Paint(void);
typedef struct {
	FL_FORM *Set_Camera;
	void *vdata;
	long ldata;
	FL_OBJECT *view;
	FL_OBJECT *front_plane;
	FL_OBJECT *back_plane;
	FL_OBJECT *scaling_factor;
	FL_OBJECT *horizontal_pixels;
	FL_OBJECT *vertical_pixels;
	FL_OBJECT *degrees;
	FL_OBJECT *form7_UPDATE;
	FL_OBJECT *perspective;
	FL_OBJECT *parallel;
} FD_Set_Camera;

extern FD_Set_Camera * create_form_Set_Camera(void);
typedef struct {
	FL_FORM *Set_View;
	void *vdata;
	long ldata;
	FL_OBJECT *eye_x_axis;
	FL_OBJECT *eye_y_axis;
	FL_OBJECT *eye_z_axis;
	FL_OBJECT *focus_x_axis;
	FL_OBJECT *focus_y_axis;
	FL_OBJECT *focus_z_axis;
	FL_OBJECT *form8_UPDATE;
} FD_Set_View;

extern FD_Set_View * create_form_Set_View(void);
typedef struct {
	FL_FORM *Set_Display;
	void *vdata;
	long ldata;
	FL_OBJECT *form3_UPDATE;
	FL_OBJECT *intensity_factor;
	FL_OBJECT *gamma_factor;
	FL_OBJECT *contrast_factor;
	FL_OBJECT *color_reduction_noise_level;
	FL_OBJECT *color_reduction_enabled;
	FL_OBJECT *gamma_enabled;
	FL_OBJECT *intensity_enabled;
	FL_OBJECT *contrast_enabled;
} FD_Set_Display;

extern FD_Set_Display * create_form_Set_Display(void);
typedef struct {
	FL_FORM *Set_Color;
	void *vdata;
	long ldata;
	FL_OBJECT *form4_UPDATE;
	FL_OBJECT *rgb_color;
	FL_OBJECT *grayscale;
	FL_OBJECT *pseudocolor;
} FD_Set_Color;

extern FD_Set_Color * create_form_Set_Color(void);
typedef struct {
	FL_FORM *Set_Convergence;
	void *vdata;
	long ldata;
	FL_OBJECT *ambient_exitance;
	FL_OBJECT *positive_overshoot;
	FL_OBJECT *maximum_steps;
	FL_OBJECT *stopping_criterion;
} FD_Set_Convergence;

extern FD_Set_Convergence * create_form_Set_Convergence(void);
typedef struct {
	FL_FORM *Entities;
	void *vdata;
	long ldata;
	FL_OBJECT *entities_file_path;
} FD_Entities;

extern FD_Entities * create_form_Entities(void);
typedef struct {
	FL_FORM *Statistics;
	void *vdata;
	long ldata;
	FL_OBJECT *instances;
	FL_OBJECT *surfaces;
	FL_OBJECT *patches;
	FL_OBJECT *elements;
	FL_OBJECT *vertices;
} FD_Statistics;

extern FD_Statistics * create_form_Statistics(void);
typedef struct {
	FL_FORM *Calculate;
	void *vdata;
	long ldata;
	FL_OBJECT *number_of_steps;
	FL_OBJECT *convergence;
	FL_OBJECT *elapsed_time;
	FL_OBJECT *maximum;
	FL_OBJECT *minimum;
	FL_OBJECT *calculate_button;
} FD_Calculate;

extern FD_Calculate * create_form_Calculate(void);
typedef struct {
	FL_FORM *getstepno;
	void *vdata;
	long ldata;
	FL_OBJECT *stepno;
} FD_getstepno;

extern FD_getstepno * create_form_getstepno(void);
typedef struct {
	FL_FORM *errormessage;
	void *vdata;
	long ldata;
	FL_OBJECT *errortext;
} FD_errormessage;

extern FD_errormessage * create_form_errormessage(void);
typedef struct {
	FL_FORM *About;
	void *vdata;
	long ldata;
} FD_About;

extern FD_About * create_form_About(void);

#endif /* FD_Paint_h_ */
