#ifndef _C_JITTER_H
#define _C_JITTER_H

#include <stdlib.h>
#include "color.h"

static const int C_LargeNum = 1024;
static const int C_TableSize = 1024;
static const int C_Mask = C_TableSize - 1;

class ColorJitter       // Color reduction filter
{
  private:
	 double *pxrand;     // Jitter lookup table pointer
	 double *pyrand;     // Jitter lookup table pointer
	 int noise;          // Noise level ( 0 - 8 )
	 int *pirand;        // Jitter lookup table pointer
	 BOOL status;        // Object status

	 double JitterX( int x, int y, int band )
	 {
		return pxrand[((x + (y << 2)) + pirand[(x + band) &
			 C_Mask]) & C_Mask];
	 }

	 double JitterY( int x, int y, int band )
	 {
		return pyrand[((y + (x << 2)) + pirand[(y + band) &
			 C_Mask]) & C_Mask];
	 }

  public:
	 ColorJitter();

	 ~ColorJitter();

	 BOOL GetStatus() { return status; }
	 int GetNoiseLevel() { return noise; }
	 void SetNoiseLevel( int n ) { noise = n % 9; }
	 void Reduce( ColorRGB *, int, int );
};

#endif

