#ifndef _CT_DELTA_H
#define _CT_DELTA_H

#include "general.h"
#include "ff_delta.h"

// Delta form factor array size
static const CT_DeltaDim = FF_ArrayRes / 2;
static const int CT_FormDim = CT_DeltaDim * CT_DeltaDim +
	 CT_DeltaDim;

// Cubic tetrahedron face co-ordinate limits
static const double CT_MinCoord = -2.0;
static const double CT_MaxCoord = 1.0;

class CubicDelta    // Cubic tetrahedron delta form factors
{
  private:
	 // Delta form factor row pointer array
	 static float *delta_array[CT_DeltaDim];

	 // Delta form factor array
	 static float ff_array[CT_FormDim];

  public:
	 CubicDelta();
         
	 // Get delta form factor
	 float GetFactor( int row, int col )
	 {
		int temp;         // Temporary variable

		if (row > col)
		{
		  temp = row;
		  row = col;
		  col = temp;
		}

		return delta_array[row][col - row];
	 }
};

#endif

