
#ifndef _PARSE_H
#define _PARSE_H

#include "../source/environ.c"
#include "transfm3.h"
//#include "win_text.h"

#define MaxLine 256     // Maximum line length

typedef Patch3 *PatchPtr;       // Patch pointer data type
typedef Surface3 *SurfacePtr;   // Surface pointer data type
typedef Vertex3 *VertexPtr;     // Vertex pointer data type

class Parse     // Environment data file parser
{
  private:
    WORD elem_cnt;              // Instance element count
    WORD patch_cnt;             // Instance patch count
    WORD surf_cnt;              // Instance surface count
    WORD vert_cnt;              // Instance vertex count
    char ent_buff[MaxLine];     // Entity file name buffer
    char line_buff[MaxLine];    // Line buffer
    char msg_buff[MaxLine];     // Message buffer
    Environ *penv;              // Environment pointer
    PatchPtr *pp_array;         // Patch pointer array ptr
    SurfacePtr *ps_array;       // Surface pointer array ptr
    Transform3 tm;              // 3-D transformation matrix
    VertexPtr *pv_array;        // Vertex pointer array ptr
    FILE *efile;              // Entity file
    FILE *ifile;              // Instance file

    BOOL ParseElements();
    BOOL ParsePatches();
    BOOL ReadVector( FILE *, double *, double *,
       double * );
    Instance *ParseEntityFile();
    Surface3 *ParseSurfaces();
    Surface3 *ReadSurface();
    Vertex3 *ParseVertices();
    Vertex3 *ReadVertex();
    void ReadLine( FILE * );
    void ReadTransform();
    void TransformInstance( Instance * );

  public:
    BOOL ParseFile( char *, char *, Environ * );
};

#endif

